- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Friends

# Extractor Class Reference

Search for all occurrences

## Detailed Description

This class represents the central module of the extraction.

This interface should be used when you want to automate map extraction. If you want to extend the current extraction possibilities by creating a custom module, you should use the MapExtractor class and related classes.

Examples:

  MeshDisplace/displacer.cpp.

Definition at line 275 of file MapExtractorAPI.h.

`#include <MapExtractorAPI.h>`

List of all members.

## Public Member Functions
| ~Extractor (void)
int | SourceCount (void) const
| Returns the number of source meshes.
mudbox::SubdivisionLevel * | Source (int iIndex) const
| Returns the address of a source mesh for a given slot.
void | SetSourceCount (int iCount)
| Sets the number of source meshes.
void | SetSource (int iIndex, mudbox::SubdivisionLevel *pSource)
| Assigns a pointer to a source slot.
bool | SourceSmoothing (void) const
| Returns true, if the limit surface of the source meshes should be used.
void | SetSourceSmoothing (bool bSourceSmoothing)
| Sets smoothing on/off for source meshes.
int | TargetCount (void) const
| Returns the number of target meshes.
mudbox::SubdivisionLevel * | Target (int iIndex) const
| Retuns a pointer to a target mesh for a given slot.
void | SetTargetCount (int iCount)
| Sets the number of target meshes.
void | SetTarget (int iIndex, mudbox::SubdivisionLevel *pTarget)
| Assigns a mesh pointer to a target mesh slot.
bool | TargetSmoothing (void) const
| Returns true, if the limit surface of the target meshes should be used.
void | SetTargetSmoothing (bool bTargetSmoothing)
| Turns limit surface on/off for target meshes.
bool | TargetUVSmoothing (void) const
| Returns true if UV of the target meshes should be smoothed.
void | SetTargetUVSmoothing (bool bSmoothUV)
| Turns UV smoothing on for the target meshes.
bool | TargetCreases (void) const
| Returns true if creasing should be used for the target meshes.
void | SetTargetCreases (bool bUse)
| Turns creasing on/off for the target meshes.
enum UtilizerType | UtilizerType (void) const
| Returns the current utilizer type. This controls what the final result of the extraction will be, default is textures.
void | SetUtilizerType (enum UtilizerType eUtilizerType)
| Sets the utilizer type. This controls what the final result of the extraction will be, default is textures.
int | MapWidth (void) const
| Returns the width of the generated textures. This is only valid when utilizer type is set to texture.
int | MapHeight (void) const
| Returns the height of the generated textures. This is only valid when utilizer type is set to texture.
void | SetMapWidth (int iWidth)
| Sets the width of the generated textures. This is only valid when utilizer type is set to texture.
void | SetMapHeight (int iHeight)
| Sets the height of the generated textures. This is only valid when utilizer type is set to texture.
enum Antialiasing | Antialiasing (void) const
| Returns the current anti-aliasing settings. Only valid when utilizer type is set to texture.
void | SetAntialiasing (enum Antialiasing eAntialiasing)
| Sets the current anti-aliasing settings. Only valid when utilizer type is set to texture.
int | EdgeBleeding (void) const
| Returns the number of pixels used for edge bleeding. -1 means the bleed value set for texture painting is used.
void | SetEdgeBleeding (int iPixels)
| Sets the width of the bleed area in pixels.
class DisplacementComponent | DisplacementComponent (void) const
| Returns the displacement component.
class VectorDisplacementComponent | VectorDisplacementComponent (void) const
| Returns the vector dispalcement component.
class NormalComponent | NormalComponent (void) const
| Returns the normal vector component.
class AmbientOcclusionComponent | AmbientOcclusionComponent (void) const
| Returns the ambient occlusion component.
class PaintLayerScanComponent | PaintLayerScanComponent (void) const
| Returns the paint layer scanner component. This is not exposed on the UI currently, but can be used programmatically.
class SculptLayerScanComponent | SculptLayerScanComponent (void) const
| Returns the sculpt layer scanner component. This is not exposed on the UI currently, but can be used programmatically.
enum LocateMethod | LocateMethod (void) const
| Returns the current locate method.
void | SetLocateMethod (enum LocateMethod eLocateMethod)
| Sets the current locate method. This controls how target surface points gets paired with source surface points.
enum Sampling | Sampling (void) const
| Returns how the final intersection point is chosen, if there are multiple candidates. This is only valid if locate method is set to raycast.
void | SetSampling (enum Sampling)
| Sets how the final intersection point is chosen, if there are multiple candidates. This is only valid if locate method is set to raycast.
float | SearchDistance (void) const
| Returns the distance from the target mesh where the ray starts and ends.
void | SetSearchDistance (float fSearchDistance)
| Sets the distance from the target mesh where the ray should start and end.
bool | TestBothSides (void) const
| Returns true, if the ray-surface intersection should also check the back of the surface, not only the front. This is only valid if locate method is set to raycast.
void | SetTestBothSides (bool bBothSides)
| If bBothSides is true, turns checking of the back of the source surface on, when calculating the ray-surface intersection. This is only valid if locate method is set to raycast.
bool | PickLowestLevel (void) const
| Returns true, if the lowest level of the source sourfaces should be used for finding the ray-surface intersection point.
void | SetPickLowestLevel (bool bPickLowest)
| Turns picking the lowest level on or off. For more details, see PickLowestLevel().
bool | Execute (bool bInterface=true)
| Executes the extraction. When bInterface is false, no gui will be displayed during the process, only the progress bar in the lower left corner.
## Friends
MEADLL Extractor | CreateNewOperation (void)
| Creates a new extractor node.
MEADLL Extractor | OperationByIndex (int)
| Returns a given existing extractor node.

## Constructor & Destructor Documentation

~Extractor | ( | void |  | ) |

## Member Function Documentation

int SourceCount | ( | void |  | ) | const

Search for all occurrences

Returns the number of source meshes.

mudbox::SubdivisionLevel* Source | ( | int | iIndex | ) | const

Search for all occurrences

Returns the address of a source mesh for a given slot.

void SetSourceCount | ( | int | iCount | ) |

Search for all occurrences

Sets the number of source meshes.

Examples:
  MeshDisplace/displacer.cpp.

void SetSource | ( | int | iIndex,
|  | mudbox::SubdivisionLevel * | pSource
| ) |  |

Search for all occurrences

Assigns a pointer to a source slot.

Examples:
  MeshDisplace/displacer.cpp.

bool SourceSmoothing | ( | void |  | ) | const

Search for all occurrences

Returns true, if the limit surface of the source meshes should be used.

void SetSourceSmoothing | ( | bool | bSourceSmoothing | ) |

Search for all occurrences

Sets smoothing on/off for source meshes.

int TargetCount | ( | void |  | ) | const

Search for all occurrences

Returns the number of target meshes.

mudbox::SubdivisionLevel* Target | ( | int | iIndex | ) | const

Search for all occurrences

Retuns a pointer to a target mesh for a given slot.

void SetTargetCount | ( | int | iCount | ) |

Search for all occurrences

Sets the number of target meshes.

Examples:
  MeshDisplace/displacer.cpp.

void SetTarget | ( | int | iIndex,
|  | mudbox::SubdivisionLevel * | pTarget
| ) |  |

Search for all occurrences

Assigns a mesh pointer to a target mesh slot.

Examples:
  MeshDisplace/displacer.cpp.

bool TargetSmoothing | ( | void |  | ) | const

Search for all occurrences

Returns true, if the limit surface of the target meshes should be used.

void SetTargetSmoothing | ( | bool | bTargetSmoothing | ) |

Search for all occurrences

Turns limit surface on/off for target meshes.

bool TargetUVSmoothing | ( | void |  | ) | const

Search for all occurrences

Returns true if UV of the target meshes should be smoothed.

void SetTargetUVSmoothing | ( | bool | bSmoothUV | ) |

Search for all occurrences

Turns UV smoothing on for the target meshes.

bool TargetCreases | ( | void |  | ) | const

Search for all occurrences

Returns true if creasing should be used for the target meshes.

void SetTargetCreases | ( | bool | bUse | ) |

Search for all occurrences

Turns creasing on/off for the target meshes.

enum UtilizerType UtilizerType | ( | void |  | ) | const

Search for all occurrences

Returns the current utilizer type. This controls what the final result of the extraction will be, default is textures.

void SetUtilizerType | ( | enum UtilizerType | eUtilizerType | ) |

Search for all occurrences

Sets the utilizer type. This controls what the final result of the extraction will be, default is textures.

Examples:
  MeshDisplace/displacer.cpp.

int MapWidth | ( | void |  | ) | const

Search for all occurrences

Returns the width of the generated textures. This is only valid when utilizer type is set to texture.

int MapHeight | ( | void |  | ) | const

Search for all occurrences

Returns the height of the generated textures. This is only valid when utilizer type is set to texture.

void SetMapWidth | ( | int | iWidth | ) |

Search for all occurrences

Sets the width of the generated textures. This is only valid when utilizer type is set to texture.

void SetMapHeight | ( | int | iHeight | ) |

Search for all occurrences

Sets the height of the generated textures. This is only valid when utilizer type is set to texture.

enum Antialiasing Antialiasing | ( | void |  | ) | const

Search for all occurrences

Returns the current anti-aliasing settings. Only valid when utilizer type is set to texture.

void SetAntialiasing | ( | enum Antialiasing | eAntialiasing | ) |

Search for all occurrences

Sets the current anti-aliasing settings. Only valid when utilizer type is set to texture.

int EdgeBleeding | ( | void |  | ) | const

Search for all occurrences

Returns the number of pixels used for edge bleeding. -1 means the bleed value set for texture painting is used.

void SetEdgeBleeding | ( | int | iPixels | ) |

Search for all occurrences

Sets the width of the bleed area in pixels.

-1 means the bleed value set for texture painting in the preferences is used. This parameter is not currently exposed on the UI, but can be set programmatically.

class DisplacementComponent DisplacementComponent | ( | void |  | ) | const

Search for all occurrences

Returns the displacement component.

class VectorDisplacementComponent VectorDisplacementComponent | ( | void |  | ) | const

Search for all occurrences

Returns the vector dispalcement component.

class NormalComponent NormalComponent | ( | void |  | ) | const

Search for all occurrences

Returns the normal vector component.

class AmbientOcclusionComponent AmbientOcclusionComponent | ( | void |  | ) | const

Search for all occurrences

Returns the ambient occlusion component.

class PaintLayerScanComponent PaintLayerScanComponent | ( | void |  | ) | const

Search for all occurrences

Returns the paint layer scanner component. This is not exposed on the UI currently, but can be used programmatically.

Examples:
  MeshDisplace/displacer.cpp.

class SculptLayerScanComponent SculptLayerScanComponent | ( | void |  | ) | const

Search for all occurrences

Returns the sculpt layer scanner component. This is not exposed on the UI currently, but can be used programmatically.

enum LocateMethod LocateMethod | ( | void |  | ) | const

Search for all occurrences

Returns the current locate method.

void SetLocateMethod | ( | enum LocateMethod | eLocateMethod | ) |

Search for all occurrences

Sets the current locate method. This controls how target surface points gets paired with source surface points.

Examples:
  MeshDisplace/displacer.cpp.

enum Sampling Sampling | ( | void |  | ) | const

Search for all occurrences

Returns how the final intersection point is chosen, if there are multiple candidates. This is only valid if locate method is set to raycast.

void SetSampling | ( | enum | Sampling | ) |

Search for all occurrences

Sets how the final intersection point is chosen, if there are multiple candidates. This is only valid if locate method is set to raycast.

float SearchDistance | ( | void |  | ) | const

Search for all occurrences

Returns the distance from the target mesh where the ray starts and ends.

The total length of the ray will be the double of this value. This is only valid if locate method is set to raycast.

void SetSearchDistance | ( | float | fSearchDistance | ) |

Search for all occurrences

Sets the distance from the target mesh where the ray should start and end.

The total length of the ray will be the double of this value. This is only valid if locate method is set to raycast.

bool TestBothSides | ( | void |  | ) | const

Search for all occurrences

Returns true, if the ray-surface intersection should also check the back of the surface, not only the front. This is only valid if locate method is set to raycast.

void SetTestBothSides | ( | bool | bBothSides | ) |

Search for all occurrences

If bBothSides is true, turns checking of the back of the source surface on, when calculating the ray-surface intersection. This is only valid if locate method is set to raycast.

bool PickLowestLevel | ( | void |  | ) | const

Search for all occurrences

Returns true, if the lowest level of the source sourfaces should be used for finding the ray-surface intersection point.

When the point is found, further calculation is done to find the matching point on the desired sudivision level of the source mesh. This is only valid if locate method is set to raycast. This is not exposed on the UI currently, but can be used programmatically.

void SetPickLowestLevel | ( | bool | bPickLowest | ) |

Search for all occurrences

Turns picking the lowest level on or off. For more details, see PickLowestLevel().

bool Execute | ( | bool | bInterface = `true` | ) |

Search for all occurrences

Executes the extraction. When bInterface is false, no gui will be displayed during the process, only the progress bar in the lower left corner.

Examples:
  MeshDisplace/displacer.cpp.

## Friends And Related Function Documentation

MEADLL Extractor CreateNewOperation | ( | void |  | ) | `[friend]`

Search for all occurrences

Creates a new extractor node.

MEADLL Extractor OperationByIndex | ( | int |  | ) | `[friend]`

Search for all occurrences

Returns a given existing extractor node.

The documentation for this class was generated from the following file:

- MapExtractorAPI/MapExtractorAPI.h

Extractor Extractor Extractor Extractor Extractor Extractor Extractor Extractor Extractor Extractor
Extractor Extractor Extractor Extractor Extractor Extractor Extractor Extractor Extractor Extractor